package dao

import (
	"fmt"
	"gorm.io/gorm"
	"iot_manager_service/util/common"
)

var Db *gorm.DB

func InitDB(db *gorm.DB) {
	Db = db
	models := []common.TableModelAuto{
		{&CaptureOverSpeed{}, "超速车牌数据明细"},
		{&ManholeCoverDao{}, "井盖数据记录表"},
	}
	for _, val := range models {
		err := Db.Set("gorm:table_options", "comment '"+val.Comment+"'").AutoMigrate(val.Model)
		if err != nil {
			panic(fmt.Sprintf("AutoMigrate err : %v", err))
		}
	}
}
