package dao

type RoleMenu struct {
	ID     int `gorm:"primary_key" json:"id"`  //编号
	MenuId int `gorm:"type:int" json:"menuId"` //菜单id
	RoleId int `gorm:"type:int" json:"roleId"` //角色id
}

func (RoleMenu) TableName() string {
	return "role_menu"
}

func (c *RoleMenu) Save() error {
	return Db.Model(&c).Save(&c).Error
}

func (c *RoleMenu) BatchSave(menus []RoleMenu) error {
	return Db.Model(&c).Save(&menus).Error
}

func (c *RoleMenu) DeleteRoleIds(roleIds []int) error {
	return Db.Model(&c).Where("role_id in ?", roleIds).Delete(&c).Error
}

func (c *RoleMenu) GetMenusByRole() ([]RoleMenu, error) {
	var menus []RoleMenu
	err := Db.Table("role_menu").Select("distinct menu_id").Where("role_id = ?", c.RoleId).Find(&menus).Error
	return menus, err
}

func (c *RoleMenu) GetAll() ([]RoleMenu, error) {
	var menus []RoleMenu
	err := Db.Table("role_menu").Select("distinct menu_id").Find(&menus).Error
	return menus, err
}
