package model

import "iot_manager_service/app/system/dao"

type RsqMenuList struct {
	Records []dao.Menu `json:"records"` //记录列表
	Current int        `json:"current"` //当前分页
	Size    int        `json:"size"`    //每页数量
	Pages   int        `json:"pages"`   //总页数
	Total   int        `json:"total"`   //总数
}

type MenuRouteDetail struct {
	dao.Menu
	HasChildren bool              `json:"hasChildren"`
	Children    []MenuRouteDetail `json:"children"`
}

type MenuTreeDetail struct {
	ID          string           `json:"id"`
	ParentId    string           `json:"parentId"`
	HasChildren bool             `json:"hasChildren"`
	Title       string           `json:"title"`
	Key         string           `json:"key"`
	Value       string           `json:"value"`
	Children    []MenuTreeDetail `json:"children"`
}

type MenuSubmit struct {
	ID       int    `json:"id"`
	ParentId int    `json:"parentId"` //父级菜单
	Code     string `json:"code"`     //菜单编号
	Name     string ` json:"name"`    //菜单名称
	Alias    string `json:"alias"`    //菜单别名
	Path     string `json:"path"`     //请求地址
	Source   string `json:"source"`   //菜单资源
	Sort     int    `json:"sort"`     //排序
	Category int    `json:"category"` //菜单类型
	Action   int    `json:"action"`   //操作按钮类型
	IsOpen   int    `json:"isOpen"`   //是否打开新页面
	Remark   string `json:"remark"`   //备注
}

type RsqMenuLazyList struct {
	List []MenuLazyListDetail `json:"data"`
}

type MenuLazyListDetail struct {
	dao.Menu
	HasChildren bool `json:"hasChildren"`
}

type ResMenuIds struct {
	Menu      []int `json:"menu"`
	DataScope []int `json:"dataScope"` //类型还未确定
	ApiScope  []int `json:"apiScope"`  //类型还未确定
}

type ResGrantTree struct {
	Menu      []MenuRouteDetail `json:"menu"`
	DataScope []int             `json:"dataScope"` //类型还未确定
	ApiScope  []int             `json:"apiScope"`  //类型还未确定
}
